Description

This is a guide for setting up CoiniumServ on FreeBSD 10.

Prepare the Environment

o Make sure the system is up to date:

pkg update && pkg upgrade
e Create a coinium user:

pw add user -n coinium -s /bin/sh -c "CoiniumServ"
e |nstall a few dependencies:

pkg install bash git mono

o Install the bitcoin daemon, refer to issue #889

Install Redis

¢ Install redis:
pkg install redis
e Start and enable redis at boot:

echo 'redis_enable="YES"' >> /etc/rc.conf
service redis start

Install MariaDB

e Start by installing the mariadb100-server and mariadb100-client packages:
pkg install mariadbl00-{server,client}
e Copy a base MySQL configuration to use:

cp /usr/local/share/mysqgl/my-small.cnf /var/db/mysgl/my.cnf

04/23/2024 1/6



http://project.altservice.com/issues/889

e Enable and start mysql at boot:

echo 'mysgl_enable="YES"' >> /etc/rc.conf
service mysgl-server start

e Prepare the database for use by running the secure installation:
NOTE: Choose a strong root password and answer yes to all questions.

mysgl_secure_installation

Create Databases and Users

e | ogin to MySQL and create appropriate databases and users.

mysgl —-u root -p

o And run the following SQL queries to create the coiniumdb database and coiniumuser user:

CREATE DATABASE coiniumdb CHARACTER SET utf8;

CREATE USER 'coiniumuser'@'localhost' IDENTIFIED BY 'SuperSecretPassword';
GRANT ALL PRIVILEGES ON coiniumdb.* TO 'coiniumuser'@'localhost';

FLUSH PRIVILEGES;

quit

Install CoiniumServ

e Download the latest CoiniumServ from GitHub:

git clone https://github.com/bonesoul/CoiniumServ.git /usr/local/CoiniumServ
cd /usr/local/CoiniumServ

git submodule init

git submodule update

e Compile the sources:

cd build/release
bash build.sh

Configure CoiniumServ

e Switch to the CoiniumServ config directory:
cd /usr/local/CoiniumServ/bin/Release/config
* Create a main config file from the example:

cp config-example.json config-example. json
e Edit the main config file:

vi config.json

o And modify accordingly:

"stack": {
"name": "pool.example.com",
"nodes": [
{
"location": "us",
"address": "pool.example.com",
"default": true
}
]
}I
"statistics": {
"updateInterval": 60,
"hashrateWindow": 300
}I
"website": {
"enabled": true,
"bind": "",
"port": 8000,
"template": "default",
"feed": "",
"backend": {
"metrics": {
"enabled": false
}
}
}I
"logging": {
"root": "logs",
"targets": [
{
"enabled": true,
"type": "file",
"filename": "server.log",
"rolling": false,
"level": "information"
}I
{
"enabled": true,
"type": "file",
"filename": "debug.log",
"rolling": false,
"level": "verbose"
}I
{
"enabled": false,
"type": "packet",
"filename": "packet.log",
"rolling": false,
"level": "verbose"

* Create a market config file
cp markets-example.json markets. json

e Create a software config file from the example:

cp software-example. json software.json

e Create a default per-pool config file:

cp pools/default-example.json pools/default. json

o Edit the default per-pool config:

vi pools/default. json

o And modify the config accordingly:

"daemon": {
"host": "127.0.0.1",
"timeout": 5

}I

"meta": {
"motd":
"txMessage":

"Welcome to CoiniumServ pool, enjoy your

"http://pool.example.com/"

}l

"payments": {
"enabled":
"interval":

"minimum" :

true,
60,
0.01
}I
"miner": {
"validateUsername":
"timeout": 300

true,

b

"job": {
"blockRefreshInterval":

55

1000,
"rebroadcastTimeout":
}I
"stratum": {
"enabled":
"bind": "0.0.0.0",
"diff": 1o,
"vardiff": {
"enabled":
"minDiff":
"maxDiff":
"targetTime":

true,

true,

8!

512,

15,
90,
"variancePercent":

"retargetTime":
30

}I

"banning": {
"enabled":
"duration":

true,
600,
"invalidPercent":
"checkThreshold":
"purgeInterval":

50,
100,
300
}l
"storage": {
"hybrid": {
"enabled": true,

"redis": {
"host": "127.0.0.1",
"port": 6379,
"password": "",

"databaseId": 0
by

"mysgl": {
"host": "127.0.0.1",
"port": 3306,
"user": "coiniumuser",
"password": "SuperSecretPassword"
}
}I
"mpos": {
"enabled": false,
"mysqgl": {
"host": "127.0.0.1",
"port": 3306,
"user": "username",
"password": "password"

e Create a bitcoin pool config:
mv pools/pool.json pools/bitcoin. json
vi pools/bitcoin. json

o And add the following:
NOTE: Make sure to set the daemon port, username and password to the match the bitcoin daemon from #889

{
"enabled": true,
"coin": "bitcoin.json",
"daemon": {
"port": 2300,
"username": "bitcoinrpc",
"password": "SuperSecretPassword"
}I
"wallet": {
"address": "15gFDeS8zsb48xc7pQWrMSDEAC2gDjg9Cn"
}I
"rewards": [

{
"15gFDeS8zsb48xc7TpQWrMSDEAC2gDjg9Cn": 1

]I
"stratum": {

"port": 3333
}I
"storage": {

"hybrid": {

"mysgl": |
"database": "coiniumdb"

e Test running the server:
mono /usr/local/CoiniumServ/bin/Release/CoiniumServ.exe

Resources

e https://github.com/bonesoul/CoiniumServ
¢ https://github.com/bonesoul/CoiniumServ/wiki/Getting-Started:-Linux
¢ https://github.com/bonesoul/CoiniumServ/wiki/Configuration

History

#1 - 04/25/2017 10:19 PM - Daniel Curtis
- Status changed from New to Resolved

- % Done changed from 0 to 30

#2 - 04/26/2017 11:33 PM - Daniel Curtis
- Description updated
- Status changed from Resolved to In Progress

- % Done changed from 30 to 60

#3 - 04/27/2017 10:22 PM - Daniel Curtis
- Description updated

- % Done changed from 60 to 70

#4 - 03/19/2018 09:06 PM - Daniel Curtis

- Status changed from In Progress to Suspended
